=== debian/changelog ===
netcdf (1:4.9.2-5ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:09:36 +0000

netcdf (1:4.9.2-5ubuntu3) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:11:39 +0000

netcdf (1:4.9.2-5ubuntu2) noble; urgency=medium

  * No-change rebuild against libhdf5-103-1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:01:40 +0000

netcdf (1:4.9.2-5ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop strlcat symbol, now provided inside glibc

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Mar 2024 09:16:04 +0100

netcdf (1:4.9.2-5) unstable; urgency=medium

  * Add dpkg-dev (>= 1.22.5) to build dependencies for t64 changes.
    (closes: #1065255)

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 02 Mar 2024 13:34:30 +0100

netcdf (1:4.9.2-4) unstable; urgency=medium

  * Replace pkg-config dependency with pkgconf.
  * Move from experimental to unstable.
    (closes: #1063168)

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 28 Feb 2024 16:11:46 +0100

netcdf (1:4.9.2-4~exp1) experimental; urgency=medium

  * Improve t64 changes to match team standards.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 05 Feb 2024 17:03:03 +0100

netcdf (1:4.9.2-3.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Graham Inggs <ginggs@debian.org>  Mon, 05 Feb 2024 15:18:21 +0000

netcdf (1:4.9.2-3ubuntu1) noble; urgency=medium

  * Drop strlcat symbol, now provided inside glibc

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 18 Dec 2023 10:16:17 +0100

netcdf (1:4.9.2-3) unstable; urgency=medium

  * Add upstream patch to finalize HDF5 library at exit.
    (closes: #1058621)
  * Update symbols file.
  * Add autopkgtest for netcdf utilities.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 16 Dec 2023 14:27:57 +0100

netcdf (1:4.9.2-2ubuntu1) mantic; urgency=medium

  * Drop strlcat symbol, now provided inside glibc

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Sep 2023 18:53:29 +0200

netcdf (1:4.9.2-2) unstable; urgency=medium

  * Remove generated files in clean target.
    (closes: #1045839)
  * Use execute_after instead of override in rules file.
  * Enable Salsa CI.
  * Add patch to fix FTBFS with doxygen 1.9.8.
    (closes: #1051162)

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 04 Sep 2023 07:51:05 +0200

netcdf (1:4.9.2-1) unstable; urgency=medium

  * Bump debhelper compat to 13.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 13 Jun 2023 17:05:29 +0200

netcdf (1:4.9.2-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 15 Mar 2023 05:32:36 +0100

netcdf (1:4.9.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Add Rules-Requires-Root to control file.
  * Bump Standards-Version to 4.6.2, no changes.
  * Refresh patches.
  * Update symbols for 4.9.1.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 06 Feb 2023 15:10:15 +0100

netcdf (1:4.9.1~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Ignore tags with 'test' suffix.
  * Drop spelling-errors.patch, applied upstream. Refresh remaining patches.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 22 Nov 2022 05:33:45 +0100

netcdf (1:4.9.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop library-version.patch, applied upstream.
  * Update symbols for 4.9.1~rc1.
  * Update lintian overrides.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Oct 2022 07:03:57 +0200
